package org.tbasket.api

import akka.actor.typed.ActorSystem
import akka.actor.typed.javadsl.Behaviors
import akka.http.scaladsl.Http
import akka.http.scaladsl.model.{ContentTypes, HttpEntity, HttpResponse}
import akka.http.scaladsl.server.Directives._

import scala.concurrent.ExecutionContextExecutor

class Endpoint(url: String, port: Int) {
implicit val system: ActorSystem[_]           = ActorSystem(Behaviors.empty, "main")
implicit val ec    : ExecutionContextExecutor = system.executionContext

private var count = 0

def countEntity = HttpEntity(ContentTypes.`application/json`, s"value: $count")

private val server = Http().newServerAt(url, port)

server.bind(concat(
    path("counter") {
        get {
            println("got get request")
            complete(countEntity)
        }
    },
    path("counter") {
        post {
            println("got request")
            count += 1
            complete(HttpResponse(entity = countEntity))
        }
    }
))


}
